<template>
  <div>
    <div class="mx-auto max-w-4xl px-6">
      <div class="text-left">
        <div class="p-6  text-white sm:rounded-lg">
          <div class="relative 
            rounded
            h-full 
            p-12 
            overflow-hidden">
            <div class="absolute inset-y-0 right-0 w-14">
              <ul class="m-3">
                <li class="cursor-pointer" @click="clickFavorite()">
                  <StarIcon class="w-8 h-8 text-white" />
                </li>
                <li class="absolute bottom-0 right-0 m-3 cursor-pointer" @click="openModal">
                  <BookmarkIcon class="w-8 h-8 text-white" />
                </li>
              </ul>
            </div>

            <div class="rounded pl-10 p-4 shadow-xl bg-black bg-opacity-20">
              <h2 class="text-3xl font-extrabold tracking-tight">{{ store.cities }} ({{ store.cityZip }})</h2>
              <p class="mt-2">{{ store.dateTime }}</p>
            </div>

            <dl class="mt-8 grid grid-cols-1 gap-x-6 gap-y-5 sm:grid-cols-2 sm:gap-y-10 lg:gap-x-8">
              <div class="relative h-20 pt-4">
                <img v-if="store.conditions.main == 'Clear'" class="absolute w-40 h-40 -mt-10"
                  src="../assets/animated/day.svg">
                <img v-else-if="store.conditions.main == 'Clouds'" class="absolute w-40 h-40 -mt-10"
                  src="../assets/animated/cloudy-day-1.svg">
                <img v-else-if="store.conditions.main == 'Rain'" class="absolute w-40 h-40 -mt-10"
                  src="../assets/animated/rainy-1.svg">
                <img v-else-if="store.conditions.main == 'Thunderstorm'" class="absolute w-40 h-40 -mt-10"
                  src="../assets/animated/thunder.svg">
              </div>
              <div class="rounded pl-10 p-4 shadow-xl bg-black bg-opacity-20">
                <!--<dt class="font-large text-md">Température</dt>-->
                <dd class="mt-2 font-medium text-5xl"> {{ store.roundedValues.temp }}&#176;C</dd>
                <dd class="mt-2 text-3xl">{{ store.conditions.description }}</dd>
              </div>
              <div class="rounded pl-10 p-4 shadow-xl bg-black bg-opacity-20">
                <dt class="font-medium text-md">Max/Min</dt>
                <dd class="mt-2 text-3xl">{{ store.roundedValues.temp_max }}&#176;C/{{ store.roundedValues.temp_min
                }}&#176;C</dd>
              </div>
              <div class="rounded pl-10 p-4 shadow-xl bg-black bg-opacity-20">
                <dt class="font-medium text-md">Humidité</dt>
                <dd class="mt-2 text-3xl">{{ store.weatherData.humidity }}&#37;</dd>
              </div>
            </dl>
          </div>
          <nav class="sticky top-4 py-8 px-2 z-40 sm:px-2">
            <div class="flex flex-col items-center justify-center mx-auto">
              <label for="sInput" class="text-xl pr-10">Saisir un code Postal</label>
              <input @keypress="search" type="text" id="sInput" v-model="cityZip" maxlength="5" pattern="\d*" class="block  w-50 
                    rounded-md 
                    drop-shadow-2xl 
                    py-2 
                    text-center
                    focus:z-10  focus:outline-none rounded p-4 shadow-xl bg-black bg-opacity-40
                    text-lg" />
            </div>
          </nav>

          <FavoriteDialog :isOpen="isOpen" @closeModal="closeModal" />

        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import { ref } from 'vue'
import { useStore } from '../store';
import { useRouter } from "vue-router";
import FavoriteDialog from '../components/FavoriteDialog.vue'
import { StarIcon } from "@heroicons/vue/outline";
import { BookmarkIcon } from "@heroicons/vue/outline";


const router = useRouter();
const store = useStore()
const isShowing = ref(true)
const isOpen = ref(false)
const cityZip = ref("");

const openModal = () => {
  isOpen.value = true
}

const closeModal = () => {
  isOpen.value = false
}

const clickFavorite = () => {
  if (!store.favorite) {
    alert("Ajouter aux Favoris");
  }
  store.addSearchToFavorite();
}

const search = async (e) => {
  if (e.key == "Enter") {
    await store.searchWeather(cityZip.value)
    if (store.error) {
      router.push({ name: "Error" });
    }
    cityZip.value = "";
  }
};
</script>